<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class FuncionarioFactory {
    protected $connection;
    protected $alias;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->alias = "func";
    }

    public function getEmployee($params) {
        $sql = "SELECT NMFUNCIONARIO, NRFUNCIONARIO
                  FROM FCM_FUNCIONARIO func";
        $whereClausule = $this->concatWhereClausule($params);
        $sql .= $whereClausule;
        $std = $this->connection->prepare($sql);
        if (strlen($whereClausule) > 0) {
            $std->execute($params);   
        } else {
            $std->execute();
        }
        return $std->fetchAll();
        //debugApi([$std->fetchAll()]);
    }
    
    protected function concatWhereClausule($params) {
        $useParams = false;
        $paramKeys = array_keys($params);
        $query = "";
        foreach($paramKeys as $key) {
            if (!$useParams) {
                $useParams = true;
                $query.= " WHERE ";
            } else {
                $query.= " AND ";
            }
            $query.= $this->alias . "." . $key . " = :" . $key;
        }
        return $query;
    }

    public function joinPerfilAcesso($params) {
        $sql = "SELECT func.NMFUNCIONARIO, func.NRFUNCIONARIO, pa.IDPERMISSSUSUARIO,
        pa.IDPERMISSSTAREFAS, pa.IDPERMISSSLOCAIS, pa.IDPERMISSSCHECKLIST,
        pa.IDPERMISSSRELATORIOS, pa.IDPERMISSSGRAFICOS, pa.IDPERMISSSVISTORIA,
        IDPERMISSSCALEND, pa.IDTIPODASHBOARD
        FROM FCM_FUNCIONARIO func
        INNER JOIN FCM_RELACFUNCPERFACESS frl
        ON func.NRFUNCIONARIO = frl.NRFUNCIONARIO
        INNER JOIN FCM_PERFILACESSO pa
        ON frl.NRPERFILACESSO = pa.NRPERFILACESSO";
        
        $whereClausule = $this->concatWhereClausule($params);
        $sql .= $whereClausule;
        $std = $this->connection->prepare($sql);
        if (strlen($whereClausule) > 0) {
            $std->execute($params);
        } else {
            $std->execute();
        }
        return $std->fetchAll();
    }
}

?>