<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class NewLocalAtendimentoFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
   
    public function getFactoryLocal() {
        $sql = "SELECT NMTIPOLOCALCLI, NRTIPOLOCALCLI, IDTIPOLOCALCLI
                  FROM FCM_TIPOLOCALCLI";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryLocalParent() {
        $sql = "SELECT FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE, FCM_TIPOLOCALCLI.IDTIPOLOCALCLI
                  FROM FCM_LOCALCLI
                  JOIN FCM_TIPOLOCALCLI
                    ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                 WHERE  FCM_TIPOLOCALCLI.IDTIPOLOCALCLI != 3";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactorySector() {
        $sql = "SELECT NMSETOR, NRSETOR
                  FROM FCM_SETOR";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryGroup() {
        $sql = "SELECT NMGRUPOLOCAL, NRGRUPOLOCAL
                  FROM FCM_GRUPOLOCAL";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryEmployee($params) {
        $sql = "SELECT NMFUNCIONARIO, NRFUNCIONARIO
                  FROM FCM_FUNCIONARIO
                 WHERE NRFUNCIONARIO IN ({$params})";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryCheckList() {
        $sql = "SELECT NMCHECKLIST, NRCHECKLIST
                  FROM FCM_CHECKLIST";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function insertFactoryLocalAt($params) {
        $sql = "INSERT INTO FCM_LOCALCLI (NRLOCALCLIENTE,NMLOCALCLIENTE,CDCLIENTE,NRTIPOLOCALCLI,NRLOCALCLIENTEPAI,NRCHECKLISTPADR,NRSETOR,DSICONELOCAL,DSQRCODE,IDATIVO,NRORG,DTINCLUSAO,CDOPERINCLUSAO,NRORGINCLUSAO,DTULTATU,CDOPERULTATU,NRORGULTATU,NRGRUPOLOCAL, DSCODIGOLOCALCLI, DSCORIDLOCAL)
                 VALUES(:NRLOCALCLIENTE, :NMLOCALCLIENTE, :CDCLIENTE, :NRTIPOLOCALCLI, :NRLOCALCLIENTEPAI, :NRCHECKLISTPADR, :NRSETOR, :DSICONELOCAL, :DSQRCODE, 'S', :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO, SYSDATE, :CDOPERULTATU, :NRORGULTATU, :NRGRUPOLOCAL, :DSCODIGOLOCALCLI, :DSCORIDLOCAL)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
    }
    
    public function insertRelacLocalChk($paramsChk) {
        $sql = "INSERT INTO FCM_RELACLOCALCHK (NRRELACLOCALCHK, NRLOCALCLIENTE, NRCHECKLIST, DTINCLUSAO, DTULTATU)
                    VALUES(:NRRELACLOCALCHK, :NRLOCALCLIENTE, :NRCHECKLIST, SYSDATE, SYSDATE)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($paramsChk);
    }
    
     // Função de inserir tarefa através da tela de criar local
    /*public function insertFactoryTask($params) {
        $sql = "INSERT INTO FCM_TAREFAAGEND
                 VALUES(:NRTAREFAAGEND, :NRCHECKLISTAGEND, :NRFUNCIONARIO, SYSDATE, :DSOBSTAREFAAGEND, 'S', :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO, :DTULTATU, :CDOPERULTATU, :NRORGULTATU, :NRTAREFACHK, 'S')";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
    }*/
    
    // Puxa os dados pra tela, pra poder atualizar
    public function getFactoryLocalAtToUpdate($param) {
        $sql = "SELECT NRLOCALCLIENTE, NMLOCALCLIENTE, NRTIPOLOCALCLI, CDCLIENTE,
                        NRLOCALCLIENTEPAI, NRCHECKLISTPADR, NRSETOR, DSCODIGOLOCALCLI, DSCORIDLOCAL
                  FROM FCM_LOCALCLI
                WHERE NRLOCALCLIENTE = :NRLOCALCLIENTE";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute($param);
        return $std->fetchAll();
    }
    
    // Atualiza os dados da tabela de local de atendimento
    public function updateFactoryLocalAt($param) {
        $sql = "UPDATE FCM_LOCALCLI
                    SET NMLOCALCLIENTE = :NMLOCALCLIENTE,
                        CDCLIENTE      = :CDCLIENTE,
                        NRTIPOLOCALCLI = :NRTIPOLOCALCLI,
                        NRLOCALCLIENTEPAI = :NRLOCALCLIENTEPAI,
                        NRCHECKLISTPADR = :NRCHECKLISTPADR,
                        NRSETOR = :NRSETOR,
                        DTULTATU = SYSDATE,
                        DSCODIGOLOCALCLI = :DSCODIGOLOCALCLI,
                        DSCORIDLOCAL = :DSCORIDLOCAL
                WHERE NRLOCALCLIENTE = :NRLOCALCLIENTE";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($param);
    }
    
    // Atualiza os dados da tabela de relação local-checklist
    public function updateRelacLocalChk($paramsChk) {
        $sql = "UPDATE FCM_RELACLOCALCHK
                    SET NRCHECKLIST = :NRCHECKLIST,
                        DTULTATU = SYSDATE
                WHERE NRLOCALCLIENTE = :NRLOCALCLIENTE";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($paramsChk);
    }
    
    public function getLocals() {
        $sql = "SELECT LOC.NMLOCALCLIENTE, LOC.NRLOCALCLIENTE, LOC.NRLOCALCLIENTEPAI, LOC.DSCODIGOLOCALCLI, LOC.CDCLIENTE,
                        TLOC.NMTIPOLOCALCLI, TLOC.IDTIPOLOCALCLI,LOC.NRTIPOLOCALCLI, LOC.NRCHECKLISTPADR, LOC.NRSETOR, LOC.DSCORIDLOCAL
                    FROM FCM_LOCALCLI LOC
                        JOIN FCM_TIPOLOCALCLI TLOC ON TLOC.NRTIPOLOCALCLI =  LOC.NRTIPOLOCALCLI
                ORDER BY TLOC.IDTIPOLOCALCLI ASC";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
}
?>